//Implementation of Omega-R.AdaBoost vs AdaBoost, NIPS 2016 code

import java.awt.*;
import javax.swing.*;
 
public class MemoryMonitor implements Debuggable
{
    public static double LIMIT_MEM = 80.0;//Beyond 80%, prints warning

    public String memString, memStringThreshold;
    public boolean stop;

    public MemoryMonitor()
    {	
	memString = memStringThreshold = "";
	stop = false;
	Thread thread =
	    new Thread()
	    {
		public void run()
		{
		    while(!stop){
			compute();
			try { Thread.sleep(3000); } catch (Exception e) {}
		    }
		}
	    };
	thread.start();
    }
 
    public void stop(){
	stop = true;
    }

    public void compute()
    {
	long pmemu, pmemm;
	double prop;
	    
	long memoryUsed = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
	
	pmemu = (long) (memoryUsed/(1024*1024));
	pmemm = (long) (Runtime.getRuntime().maxMemory() / (1024*1024));

	prop = 100.0 * ( (double) pmemu / (double) pmemm );

	memString = "[" + DF0.format(prop) + " %M]";
	
	if (prop > MemoryMonitor.LIMIT_MEM)
	    memStringThreshold = "[! " + DF0.format(prop) + " %M]";
	else
	    memStringThreshold = "";
    }
}
